#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>

typedef  union  semun {
	int	val;
	struct	semid_ds *buff;
	ushort	*array;
} semaphore;


main( )
{
	int i;
	int sem_ID;
	semaphore  option;


	if((sem_ID = semget(100, 1, 0600 | IPC_CREAT)) < 0)
		{
		perror("semget");
		exit(1);
		}

	option.val = 1;
	if(semctl(sem_ID, 0, SETVAL, option) < 0)
		{
		perror("semctl");
		exit(1);
		}

	for(i = 0;i < 3;i++)
		if(fork( ) == 0)
			child_process(sem_ID);
}

child_process(int sem_ID)
{
	pid_t pid = getpid( );

	printf("[%d] before\n", pid);
	sem_lock(sem_ID);
	printf("[%d] in\n", pid);

	sleep(3);

	sem_unlock(sem_ID);
	printf("[%d] end\n", pid);
	exit(0);
}

sem_lock(int sem_ID)
{
	struct	sembuf  option;

	option.sem_num = 0;
	option.sem_op  = -1;
	option.sem_flg = SEM_UNDO;

	if(semop(sem_ID, &option, 1) < 0)
		{
		perror("semop");
		exit(1);
		}

}

sem_unlock(int sem_ID)
{
	struct sembuf  option;

	option.sem_num = 0;
	option.sem_op  = 1;
	option.sem_flg = SEM_UNDO | IPC_NOWAIT;

	if(semop(sem_ID, &option, 1) < 0)
		{
		perror("semop");
		exit(1);
		}

}
