#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <stdlib.h>

struct sembuf  lock_sem[2] =
	{
	0, 0, 0,
	0, 1, SEM_UNDO
	};

struct sembuf  unlock_sem[1] =
	{
	0, -1, (IPC_NOWAIT | SEM_UNDO)
	};

typedef  union  semun {
	int val;
	struct semid_ds *buff;
	ushort *array;
} semaphore;

main( )
{
	int i;
	int sem_ID;
	semaphore option;


	if((sem_ID = semget(100, 1, 0600 | IPC_CREAT)) < 0)
		{
		perror("semget");
		exit(1);
		}

	option.val = 0;
	if(semctl(sem_ID, 0, SETVAL, option) < 0)
		{
		perror("semctl");
		exit(1);
		}

	for(i = 0;i < 3;i++)
		if(fork( ) == 0)
			child_process(sem_ID);

}

child_process(int sem_ID)
{
	pid_t pid = getpid( );

	printf("[%d] before\n", pid);
	sem_lock(sem_ID);
	printf("[%d] in\n", pid);

	sleep(3);

	sem_unlock(sem_ID);
	printf("[%d] after\n", pid);
	exit(0);
}

sem_lock(int sem_ID)
{
	if(semop(sem_ID, &lock_sem[0], 2) < 0)
		{
		perror("semop");
		exit(1);
		}
}

sem_unlock(int sem_ID)
{
	if(semop(sem_ID, &unlock_sem[0], 1) < 0)
		{
		perror("semop");
		exit(1);
		}
}
