#include <stdio.h>
#include <utmpx.h>
#include <pwd.h>
#include <sys/stat.h>

main(int argc, char *argv[])
{
        void    print_local_information();

        print_local_information();
}

void
print_local_information()
{
	void	fatal(char *);
	void	get_idle_time(time_t, char *);
	char	*week[7] = {"Sun", "Mon", "Tue", "Wen", "Thr", "Fri", "Sat"};
	char	user_name[20];
	char	idle_time[20];
	char	device_name[20];
	time_t	idle_second;
	time_t	current;
	struct	tm	*old;
	struct	utmpx	*utmpx;
	struct	passwd	*pass;
	struct	stat	device_stat;


	printf("%-12s %-10s %-10s %10s %s %10s\n",
		"Login", "Name", "TTY", "Idle", "When", "Where");

	while((utmpx = getutxent()) != NULL)
		{
		strcpy(device_name, "/dev/");
		if(utmpx->ut_type != USER_PROCESS)
			continue;

		if((pass = getpwnam(utmpx->ut_user)) != NULL)
			strcpy(user_name, pass->pw_gecos);
		else	sprintf(user_name, "%d", pass->pw_uid);
		old = localtime(&utmpx->ut_tv.tv_sec);
	 	
		strcat(device_name, utmpx->ut_line);
		if(stat(device_name, &device_stat) < 0)
			fatal("stat");

		time(&current);
		if(current < device_stat.st_atime)
			idle_second = 0L;
		else	idle_second = current - device_stat.st_atime;

		strcpy(idle_time, "");
		get_idle_time(idle_second, idle_time);

		printf("%-12s %-10s %-10s %10s %s %d:%02d %-15s\n",
			utmpx->ut_user, user_name, utmpx->ut_line, idle_time,
			week[old->tm_wday], old->tm_hour,  old->tm_min, utmpx->ut_host);
		}
}

void
get_idle_time(time_t idle_second, char *idle_time)
{
	int	minute, hour, days;
	int	idle_minute, idle_hour;


	minute = hour = days = 0;
	idle_minute = idle_hour = 0;

	minute = idle_second / 60;

	if(minute)
		hour = minute / 60;
	else	minute = 0;

	if(hour)
		{
		idle_minute = minute % 60;
		days = hour / 24;
		}
	else	idle_minute = minute;

	if(days)
		idle_hour = hour % 24;
	else	idle_hour = hour;

	if(days)
		sprintf(idle_time, "%d day", days);
	if(hour)
		sprintf(idle_time, "%s %d:", idle_time, idle_hour);
	if(minute)
		sprintf(idle_time, "%s%d", idle_time, idle_minute);

}

void
fatal(char *error_name)
{
	perror(error_name);
	exit(1);
}
